import java.util.NoSuchElementException;
import java.lang.UnsupportedOperationException;

public class ListIterator {

    protected ListElem currentElem;
    protected ListElem nextElem;

    ListIterator(ListElem elem) {
        nextElem = elem;
    }
    public boolean hasNext() {
        return nextElem != null;
    }
    public Object next() throws NoSuchElementException {
        if (nextElem == null) {
            throw new NoSuchElementException();
        }
        currentElem = nextElem;
        nextElem = nextElem.getTail();
        return currentElem.getValue();
    }
    public void remove() throws UnsupportedOperationException {
        throw new UnsupportedOperationException();
    }
}
